"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const path_1 = require("path");
const shell = require("shelljs");
const codegen_1 = require("../../lib/codegen");
const logger_1 = require("../../lib/logger");
let default_1 = class default_1 extends clime_1.Command {
    execute(name, fields) {
        const dataFields = (fields || '')
            .trim()
            .split(' ')
            .map(str => {
            const [fieldName, type] = str.split(':');
            const initialValues = {
                any: '{}',
                boolean: 'false',
                number: '0',
                string: `''`,
            };
            return { name: fieldName, type, initial: initialValues[type] };
        });
        const gen = codegen_1.generateModel(name, { fields: dataFields });
        shell.mkdir('-p', 'models');
        const dest = path_1.join(shell.pwd().toString(), 'models', `${name}.ts`);
        gen.toFile(dest);
        logger_1.log(`created model in: ${dest}`);
    }
};
__decorate([
    __param(0, clime_1.param({ description: 'name of the data model', required: true })),
    __param(1, clime_1.param({
        description: 'list of data fields, like: `status:string done:boolean`',
        required: false,
    })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", void 0)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({ description: 'scaffold a new data model' })
], default_1);
exports.default = default_1;
//# sourceMappingURL=model.js.map