"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const helper_1 = require("../lib/build/helper");
const helper_2 = require("../lib/build/helper");
const transforms_1 = require("../lib/build/transforms");
const bundler_1 = require("../lib/build/bundler");
const compiler_1 = require("../lib/build/compiler");
class BuildOptions extends clime_1.Options {
}
__decorate([
    clime_1.option({
        default: true,
        description: 'do an optimized build',
        flag: 'o',
        name: 'optimize',
        placeholder: 'true | false',
        required: false,
    }),
    __metadata("design:type", Boolean)
], BuildOptions.prototype, "optimize", void 0);
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const optimize = options && process.env.NODE_ENV !== 'test' ? options.optimize : false;
            if (process.env.NODE_ENV !== 'test') {
                helper_2.lint();
                helper_2.prettier();
            }
            helper_1.cleanBuildDirectory();
            helper_2.initFolder();
            compiler_1.Compiler.compile();
            transforms_1.modifyScriptExports();
            transforms_1.addImportIndexFile();
            helper_2.copyAssets();
            yield bundler_1.Bundler.bundle(optimize);
            helper_2.createServerlessYaml();
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [BuildOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({ description: 'compile a seagull app into a deployable bundle' })
], default_1);
exports.default = default_1;
//# sourceMappingURL=build.js.map