"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator];
    return m ? m.call(o) : typeof __values === "function" ? __values(o) : o[Symbol.iterator]();
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const helper_1 = require("../lib/build/helper");
const transforms_1 = require("../lib/build/transforms");
const logger_1 = require("../lib/logger");
const bundler_1 = require("../lib/build/bundler");
const compiler_1 = require("../lib/build/compiler");
const app_1 = require("../lib/loader/app");
const index_1 = require("../lib/server/index");
class SomeOptions extends clime_1.Options {
}
__decorate([
    clime_1.option({
        description: 'port for the dev server',
        flag: 'p',
        name: 'port',
        placeholder: '3000',
        required: false,
    }),
    __metadata("design:type", Number)
], SomeOptions.prototype, "port", void 0);
exports.SomeOptions = SomeOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const port = options && options.port ? options.port : 3000;
            logger_1.log(`> starting dev server with live reload on port ${port}...`);
            const server = new index_1.Server();
            server.start(port);
            helper_1.lint();
            helper_1.prettier();
            const bundler = new bundler_1.Bundler(false);
            helper_1.cleanBuildDirectory();
            helper_1.initFolder();
            helper_1.copyAssets();
            compiler_1.Compiler.compile();
            let app = new app_1.default(process.cwd());
            server.loadApp(app);
            try {
                for (var _a = __asyncValues(new compiler_1.Compiler().watch()), _b; _b = yield _a.next(), !_b.done;) {
                    const compiled = yield _b.value;
                    transforms_1.modifyScriptExports();
                    transforms_1.addImportIndexFile();
                    yield bundler.bundle();
                    app = new app_1.default(process.cwd());
                    yield app.loadFrontendBundle();
                    server.loadApp(app);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) yield _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
            var e_1, _c;
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SomeOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'start local dev server for your app with live reload',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=dev.js.map