"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const class_1 = require("./class");
const function_1 = require("./function");
function default_1(name, classic) {
    const gen = classic ? generateClass(name) : generateFunction(name);
    gen.addDefaultImport('react', 'React', true);
    return gen;
}
exports.default = default_1;
function generateClass(name) {
    const gen = new class_1.default(name, 'React.Component<IProps, IState>', true);
    gen.addConstructor({
        bodyText: 'super(props)\n this.state = {}',
        parameters: [{ name: 'props', type: 'IProps' }],
    });
    const docRender = `outputs the HTML of this Page`;
    const bodyRender = `
    return (
      <div>
        <h1>Hello World!</h1>
      </div>
    )`;
    gen.addMethod({
        body: bodyRender,
        doc: docRender,
        name: 'render',
        parameter: [],
        returnType: undefined,
    });
    return gen;
}
function generateFunction(name) {
    const gen = new function_1.default(name);
    gen.addParam('{ children }');
    gen.setBodyText(`
    return (
      <>
        <div>replace me!</div>
      </>
    );
    `);
    return gen;
}
//# sourceMappingURL=generate_component_tsx.js.map