"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const class_1 = require("./class");
function generateModel(name, options) {
    const gen = new class_1.default(name, 'Model');
    gen.addNamedImports('@seagull-js/seagull', ['field', 'Model']);
    if (!options.fields || !options.fields.length) {
        return gen;
    }
    for (const field of options.fields) {
        if (!field.name || !field.type || !field.initial) {
            continue;
        }
        gen.addProp({
            decorators: [{ name: 'field' }],
            name: field.name,
            type: field.type,
            value: field.initial,
        });
    }
    return gen;
}
exports.default = generateModel;
//# sourceMappingURL=generate_model.js.map