"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const json_1 = require("./json");
function generatePackageJson(name) {
    const gen = new json_1.default();
    gen.set('name', name);
    gen.set('version', '0.1.0');
    gen.set('description', 'my new seagull app');
    gen.set('private', true);
    gen.set('engineStrict', true);
    gen.set('engines', { node: '>= 6.10.3 < 7' });
    gen.set('dependencies', { '@seagull-js/seagull': `^${frameworkVersion()}` });
    gen.set('devDependencies', {
        '@types/history': '^4.6.0',
        '@types/node': '^8.0.25',
        '@types/react': '^16.0.10',
        '@types/react-dom': '^16.0.1',
        '@types/react-router': '^4.0.15',
        '@types/react-router-config': '^1.0.4',
        '@types/react-router-dom': '^4.0.8',
    });
    return gen;
}
exports.default = generatePackageJson;
function frameworkVersion() {
    const file = path_1.join(__dirname, '..', '..', '..', 'package.json');
    const pkg = require(file);
    return pkg.dependencies['@seagull-js/seagull'];
}
//# sourceMappingURL=generate_package_json.js.map