"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const json_1 = require("./json");
function generateTsconfigJson() {
    const gen = new json_1.default();
    const srcFile = path_1.join(__dirname, '..', '..', '..', 'tsconfig.json');
    gen.fromFile(srcFile);
    gen.update('compilerOptions', opts => {
        opts.rootDir = './';
        opts.outDir = './.seagull/dist';
    });
    gen.set('lib', ['es5', 'es6', 'es7', 'dom', 'dom.iterable']);
    gen.set('include', [
        'backend/**/*',
        'frontend/**/*',
        'models/**/*',
        'test/**/*',
    ]);
    return gen;
}
exports.default = generateTsconfigJson;
//# sourceMappingURL=generate_tsconfig_json.js.map