"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
class Json {
    constructor() {
        this.file = {};
    }
    get(key) {
        return this.file[key];
    }
    set(key, value) {
        this.file[key] = value;
        return this;
    }
    update(key, fn) {
        fn(this.file[key]);
        return this;
    }
    unset(key) {
        delete this.file[key];
        return this;
    }
    fromFile(filePath) {
        this.file = require(filePath);
        return this;
    }
    toString() {
        return JSON.stringify(this.file, null, 2);
    }
    toFile(filePath) {
        fs_1.writeFileSync(filePath, this.toString(), 'utf-8');
    }
}
exports.default = Json;
//# sourceMappingURL=json.js.map