"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const decache = require("decache");
const tsnode = require("ts-node");
tsnode.register({ fast: true });
class ApiHandler {
    constructor(appName, filePath) {
        this.appName = appName;
        this.filePath = filePath;
        this.generateName();
        this.generateHandler();
        this.loadModule();
    }
    generateName() {
        const id = this.filePath
            .split('/api/')
            .reverse()[0]
            .replace(/\//g, '-')
            .replace(/\.ts$/, '')
            .replace(/\.js$/, '');
        this.name = `api-${id}`;
    }
    generateHandler() {
        const id = this.filePath
            .split('/api/')
            .reverse()[0]
            .replace(/\.ts$/, '.handler')
            .replace(/\.js$/, '.handler');
        this.handler = `dist/backend/api/${id}`;
    }
    loadModule() {
        decache(this.filePath);
        this.module = require(this.filePath).default;
    }
}
exports.default = ApiHandler;
//# sourceMappingURL=api_handler.js.map