"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const decache = require("decache");
const fs_1 = require("fs");
const path_1 = require("path");
const api_1 = require("./api");
const models_1 = require("./models");
class App {
    constructor(folder) {
        this.folder = folder;
        this.backend = [];
        this.name = '';
        this.models = [];
        this.loadPackageJson();
        this.loadApiHandlers();
        this.loadDdbModels();
    }
    loadFrontendBundle() {
        return __awaiter(this, void 0, void 0, function* () {
            this.frontend = fs_1.readFileSync(path_1.join(this.folder, '.seagull', 'assets', 'bundle.js')).toString('utf-8');
        });
    }
    loadPackageJson() {
        const file = path_1.join(this.folder, '.seagull', 'package.json');
        decache(file);
        this.package = require(file);
        this.name = this.package.name;
    }
    loadApiHandlers() {
        const folder = path_1.join(this.folder, '.seagull', 'dist', 'backend', 'api');
        this.backend = api_1.default(this.name, folder);
    }
    loadDdbModels() {
        const folder = path_1.join(this.folder, '.seagull', 'dist', 'models');
        this.models = models_1.default(this.name, folder);
    }
}
exports.default = App;
//# sourceMappingURL=app.js.map