"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Endpoint {
    constructor(origin, opt) {
        this.cachedMethods = ['HEAD', 'GET', 'OPTIONS'];
        this.cookieForward = {
            Forward: 'none',
        };
        this.ttl = 0;
        this.origin = origin;
        if (opt) {
            this.path = opt.path;
            this.ttl = opt.ttl;
        }
    }
    json() {
        return {
            AllowedMethods: this.allowedMethods,
            CachedMethods: this.cachedMethods,
            Compress: true,
            DefaultTTL: this.ttl,
            ForwardedValues: {
                Cookies: this.cookieForward,
                Headers: this.targetHeaders,
                QueryString: true,
            },
            MaxTTL: this.ttl,
            MinTTL: this.ttl,
            PathPattern: this.path,
            TargetOriginId: this.origin,
            ViewerProtocolPolicy: 'redirect-to-https',
        };
    }
}
exports.Endpoint = Endpoint;
//# sourceMappingURL=endpoint.js.map