"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const gwEndpoint_1 = require("./gwEndpoint");
const target_1 = require("./target");
class GWTarget extends target_1.Target {
    constructor() {
        super(...arguments);
        this.endpointClass = gwEndpoint_1.GWEndpoint;
    }
    get targetId() {
        return `apiGW-${this.targetShortId}`;
    }
    config() {
        return {
            CustomOriginConfig: {
                OriginProtocolPolicy: 'match-viewer',
            },
            DomainName: {
                'Fn::Join': [
                    '',
                    [
                        {
                            Ref: 'ApiGatewayRestApi',
                        },
                        '.execute-api.${self:provider.region}.amazonaws.com',
                    ],
                ],
            },
            Id: this.targetId,
            OriginPath: '/${self:provider.stage}',
        };
    }
}
exports.GWTarget = GWTarget;
//# sourceMappingURL=gwTarget.js.map