"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const s3Endpoint_1 = require("./s3Endpoint");
const target_1 = require("./target");
class S3Target extends target_1.Target {
    constructor(targetShortId, accessOriginResourceName, paths) {
        super(targetShortId, paths);
        this.endpointClass = s3Endpoint_1.S3Endpoint;
        this.targetShortId = targetShortId;
        this.accessOriginResourceName = accessOriginResourceName;
    }
    get targetId() {
        return `s3-assets`;
    }
    config() {
        return {
            DomainName: `${this.targetShortId}.s3.amazonaws.com`,
            Id: this.targetId,
            S3OriginConfig: {
                OriginAccessIdentity: {
                    'Fn::Join': [
                        '',
                        [
                            'origin-access-identity/cloudfront/',
                            {
                                Ref: this.accessOriginResourceName,
                            },
                        ],
                    ],
                },
            },
        };
    }
}
exports.S3Target = S3Target;
//# sourceMappingURL=s3Target.js.map