"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function generateS3BucketPermission(resourceName, accessIdentityResourceName) {
    return {
        Properties: {
            Bucket: {
                Ref: resourceName,
            },
            PolicyDocument: {
                Statement: [
                    {
                        Action: ['s3:GetObject', 's3:GetObjectAcl'],
                        Effect: 'Allow',
                        Principal: {
                            CanonicalUser: {
                                'Fn::GetAtt': [accessIdentityResourceName, 'S3CanonicalUserId'],
                            },
                        },
                        Resource: {
                            'Fn::Join': ['', ['arn:aws:s3:::', { Ref: resourceName }, '/*']],
                        },
                    },
                ],
            },
        },
        Type: 'AWS::S3::BucketPolicy',
    };
}
exports.generateS3BucketPermission = generateS3BucketPermission;
//# sourceMappingURL=permission.js.map