"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenBaseTest = class CodegenBaseTest {
    'can be initialized'() {
        const gen = new codegen_1.Base();
        chai_1.expect(gen).to.be.an('object');
    }
    'can add default import to file'() {
        const gen = new codegen_1.Base();
        gen.addDefaultImport('moduleName', 'Mod');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import Mod from 'moduleName'`);
    }
    'can add legacy import to file'() {
        const gen = new codegen_1.Base();
        gen.addDefaultImport('moduleName', 'Mod', true);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import * as Mod from 'moduleName'`);
    }
    'can add named imports to file'() {
        const gen = new codegen_1.Base();
        gen.addNamedImports('mod', ['a', 'b']);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { a, b } from 'mod'`);
    }
    'can add interface to file'() {
        const gen = new codegen_1.Base();
        gen.addInterface('ITest');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`interface ITest {}`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenBaseTest.prototype, "can be initialized", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenBaseTest.prototype, "can add default import to file", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenBaseTest.prototype, "can add legacy import to file", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenBaseTest.prototype, "can add named imports to file", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenBaseTest.prototype, "can add interface to file", null);
CodegenBaseTest = __decorate([
    mocha_typescript_1.suite
], CodegenBaseTest);
//# sourceMappingURL=base.js.map