"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenClassTest = class CodegenClassTest {
    'can be initialized'() {
        const gen = new codegen_1.Class('MyClass');
        chai_1.expect(gen).to.be.an('object');
    }
    'can add imports to class file'() {
        const gen = new codegen_1.Class('MyClass');
        gen.addDefaultImport('moduleName', 'Mod');
        gen.addNamedImports('mod', ['a', 'b']);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import Mod from 'moduleName'`);
    }
    'can add properties to class'() {
        const gen = new codegen_1.Class('MyClass');
        gen.addProp({ name: 'counter', type: 'number', value: '0' });
        gen.addProp({ name: 'title', type: 'string', value: `'bla'`, static: true });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`counter: number = 0`);
        chai_1.expect(code).to.contain(`static title: string = 'bla'`);
    }
    'can add methods to class'() {
        const gen = new codegen_1.Class('MyClass');
        const parameter = [{ name: 'a', type: 'string' }];
        gen.addMethod({ name: 'm1', parameter, static: true });
        gen.addMethod({ name: 'm2', body: `return 'hello'`, async: true });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static m1(a: string) {}`);
        chai_1.expect(code).to.contain(`async m2() {`);
        chai_1.expect(code).to.contain(`return 'hello'`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenClassTest.prototype, "can be initialized", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenClassTest.prototype, "can add imports to class file", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenClassTest.prototype, "can add properties to class", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenClassTest.prototype, "can add methods to class", null);
CodegenClassTest = __decorate([
    mocha_typescript_1.suite
], CodegenClassTest);
//# sourceMappingURL=class.js.map