"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenGenerateApiTest = class CodegenGenerateApiTest {
    'can generate minimal API'() {
        const gen = codegen_1.generateAPI('MyAPI', {});
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { API, Request, Response } from '@seagull`);
        chai_1.expect(code).to.contain('export default class MyAPI extends API {');
        chai_1.expect(code).to.contain('async handle(request: Request): Promise<Response>');
    }
    'can generate API with path and automatic method addition'() {
        const opts = { path: '/hi' };
        const gen = codegen_1.generateAPI('MyAPI', opts);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static path: string = '/hi'`);
        chai_1.expect(code).to.contain(`static method: string = 'GET'`);
    }
    'can generate API with path and explicit method'() {
        const opts = { path: '/ho', method: 'POST' };
        const gen = codegen_1.generateAPI('MyAPI', opts);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static path: string = '/ho'`);
        chai_1.expect(code).to.contain(`static method: string = 'POST'`);
    }
    'can generate API with path activated CORS'() {
        const opts = { path: '/ha', cors: true };
        const gen = codegen_1.generateAPI('MyAPI', opts);
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static path: string = '/ha'`);
        chai_1.expect(code).to.contain(`static cors: boolean = true`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateApiTest.prototype, "can generate minimal API", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateApiTest.prototype, "can generate API with path and automatic method addition", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateApiTest.prototype, "can generate API with path and explicit method", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateApiTest.prototype, "can generate API with path activated CORS", null);
CodegenGenerateApiTest = __decorate([
    mocha_typescript_1.suite
], CodegenGenerateApiTest);
//# sourceMappingURL=generate_api.js.map