"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenGenerateLayoutTsxTest = class CodegenGenerateLayoutTsxTest {
    'can be initialized'() {
        const gen = codegen_1.generateLayoutTsx('Demo App');
        chai_1.expect(gen).to.be.an('object');
    }
    'begins with correct react import'() {
        const gen = codegen_1.generateLayoutTsx('Demo App');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import * as React from 'react'`);
    }
    'contains props-children param'() {
        const gen = codegen_1.generateLayoutTsx('Demo App');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`function Layout({ children }) {`);
    }
    'contains props-children insertion slot'() {
        const gen = codegen_1.generateLayoutTsx('Demo App');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`<div id="root">{children}</div>`);
    }
    'contains script tag for frontend bundle'() {
        const gen = codegen_1.generateLayoutTsx('Demo App');
        const code = gen.toString();
        chai_1.expect(code).to.contain(`<script src="/assets/bundle.js" />`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateLayoutTsxTest.prototype, "can be initialized", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateLayoutTsxTest.prototype, "begins with correct react import", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateLayoutTsxTest.prototype, "contains props-children param", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateLayoutTsxTest.prototype, "contains props-children insertion slot", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateLayoutTsxTest.prototype, "contains script tag for frontend bundle", null);
CodegenGenerateLayoutTsxTest = __decorate([
    mocha_typescript_1.suite
], CodegenGenerateLayoutTsxTest);
//# sourceMappingURL=generate_layout_tsx.js.map