"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenGenerateModelTest = class CodegenGenerateModelTest {
    'can generate minimal Model'() {
        const gen = codegen_1.generateModel('MyModel', { fields: [] });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { field, Model } from '@seagull`);
        chai_1.expect(code).to.contain('export default class MyModel extends Model {}');
    }
    'can generate Model with fields'() {
        const fields = [
            { name: 'done', type: 'boolean', initial: 'false' },
            { name: 'text', type: 'string', initial: `''` },
        ];
        const gen = codegen_1.generateModel('MyModel', { fields });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { field, Model } from '@seagull`);
        chai_1.expect(code).to.contain('export default class MyModel extends Model {');
        chai_1.expect(code).to.contain(`@field done: boolean = false`);
        chai_1.expect(code).to.contain(`@field text: string = ''`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateModelTest.prototype, "can generate minimal Model", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateModelTest.prototype, "can generate Model with fields", null);
CodegenGenerateModelTest = __decorate([
    mocha_typescript_1.suite
], CodegenGenerateModelTest);
//# sourceMappingURL=generate_model.js.map