"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenGeneratePageTest = class CodegenGeneratePageTest {
    'can generate minimal API'() {
        const gen = codegen_1.generatePage('MyPage', { path: '/' });
        const code = gen.toString();
        chai_1.expect(code).to.contain('export default class MyPage extends Page<{}, {}>');
    }
    'begins with correct react import'() {
        const gen = codegen_1.generatePage('MyPage', { path: '/' });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import * as React from 'react'`);
    }
    'contains correct Page import'() {
        const gen = codegen_1.generatePage('MyPage', { path: '/something' });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { Page } from '@seagull-js/seagull'`);
    }
    'contains correct path setting as prop'() {
        const gen = codegen_1.generatePage('MyPage', { path: '/something' });
        const code = gen.toString();
        chai_1.expect(code).to.contain(`path: string = '/something'`);
    }
    'contains render method'() {
        const gen = codegen_1.generatePage('MyPage', { path: '/something' });
        const code = gen.toString();
        chai_1.expect(code).to.contain('render() {');
        chai_1.expect(code).to.contain('<h1>Hello World!</h1>');
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGeneratePageTest.prototype, "can generate minimal API", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGeneratePageTest.prototype, "begins with correct react import", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGeneratePageTest.prototype, "contains correct Page import", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGeneratePageTest.prototype, "contains correct path setting as prop", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGeneratePageTest.prototype, "contains render method", null);
CodegenGeneratePageTest = __decorate([
    mocha_typescript_1.suite
], CodegenGeneratePageTest);
//# sourceMappingURL=generate_page.js.map