"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenGenerateSsrApiTest = class CodegenGenerateSsrApiTest {
    'can generate SSR API'() {
        const gen = codegen_1.generateSsrApi();
        const code = gen.toString();
        chai_1.expect(code).to.contain('export default class Frontent extends API {');
        chai_1.expect(code).to.contain('async handle(request: Request): Promise<Response>');
    }
    'contains correct imports'() {
        const gen = codegen_1.generateSsrApi();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`import { API, Request, Response } from '@seagull`);
        chai_1.expect(code).to.contain(`import { Routing } from '@seagull`);
        chai_1.expect(code).to.contain(`import { renderToString } from 'react-dom/server'`);
        chai_1.expect(code).to.contain(`import layout from '../../frontend/layout'`);
    }
    'contains correct path'() {
        const gen = codegen_1.generateSsrApi();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static path: string = '/*'`);
    }
    'contains correct http method'() {
        const gen = codegen_1.generateSsrApi();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`static method: string = 'GET'`);
    }
    'has correct handler body'() {
        const gen = codegen_1.generateSsrApi();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`return this.html(`);
        chai_1.expect(code).to.contain(`renderToString(layout({ children: new Routing`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateSsrApiTest.prototype, "can generate SSR API", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateSsrApiTest.prototype, "contains correct imports", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateSsrApiTest.prototype, "contains correct path", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateSsrApiTest.prototype, "contains correct http method", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenGenerateSsrApiTest.prototype, "has correct handler body", null);
CodegenGenerateSsrApiTest = __decorate([
    mocha_typescript_1.suite
], CodegenGenerateSsrApiTest);
//# sourceMappingURL=generate_ssr_api.js.map