"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_typescript_1 = require("mocha-typescript");
const codegen_1 = require("../../../lib/codegen");
let CodegenTsconfigJsonTest = class CodegenTsconfigJsonTest {
    'can be initialized'() {
        const gen = codegen_1.generateTsconfigJson();
        chai_1.expect(gen).to.be.an('object');
    }
    'react is enabled for frontend code'() {
        const gen = codegen_1.generateTsconfigJson();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`"jsx": "react"`);
    }
    'outfolder is hardcoded for serverless deployment'() {
        const gen = codegen_1.generateTsconfigJson();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`"outDir": "./.seagull/dist"`);
    }
    'decorators are enabled fully for backend models'() {
        const gen = codegen_1.generateTsconfigJson();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`"experimentalDecorators": true`);
        chai_1.expect(code).to.contain(`"emitDecoratorMetadata": true,`);
    }
    'modern transpilation with sourcemaps are enabled for better debugging'() {
        const gen = codegen_1.generateTsconfigJson();
        const code = gen.toString();
        chai_1.expect(code).to.contain(`"target": "es6"`);
        chai_1.expect(code).to.contain(`"sourceMap": true`);
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenTsconfigJsonTest.prototype, "can be initialized", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenTsconfigJsonTest.prototype, "react is enabled for frontend code", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenTsconfigJsonTest.prototype, "outfolder is hardcoded for serverless deployment", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenTsconfigJsonTest.prototype, "decorators are enabled fully for backend models", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CodegenTsconfigJsonTest.prototype, "modern transpilation with sourcemaps are enabled for better debugging", null);
CodegenTsconfigJsonTest = __decorate([
    mocha_typescript_1.suite
], CodegenTsconfigJsonTest);
//# sourceMappingURL=generate_tsconfig_json.js.map